=== debian/changelog ===
roctracer (5.7.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 27 Feb 2025 16:54:07 -0700

roctracer (5.7.1-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1087896)

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 20 Nov 2024 01:20:51 -0700
