=== debian/control ===
Source: roctracer
Section: devel
Homepage: https://github.com/ROCm/roctracer
Priority: optional
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/rocm-team/roctracer.git
Vcs-Browser: https://salsa.debian.org/rocm-team/roctracer
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@slerp.xyz>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               cmake,
               libhsa-runtime-dev,
               libamdhip64-dev,
               rocm-device-libs-17,
               python3

#Package: libroctracer64-4
#Section: libs
#Architecture: amd64 arm64 ppc64el
#Depends: ${misc:Depends}, ${shlibs:Depends},
#Description: todo

Package: libroctx64-4
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for profiler annotations - library
 The ROC-TX library provides functions can be used to add information
 to ROCm GPU profiler traces, thereby helping to correlate low-level
 events (e.g. kernel launches) with the high-level functionality that
 they implement.
 .
 This package provides the AMD ROCm ROC-TX library.

#Package: libroctracer-dev
#Section: libdevel
#Architecture: amd64 arm64 ppc64el
#Depends: libroctracer64-4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
#Description: todo

Package: libroctx-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libroctx64-4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: ROCm library for profiler annotations - headers
 The ROC-TX library provides functions can be used to add information
 to ROCm GPU profiler traces, thereby helping to correlate low-level
 events (e.g. kernel launches) with the high-level functionality that
 they implement.
 .
 This package provides the AMD ROCm ROC-TX development headers.
