=== debian/changelog ===
roctracer (6.4.1-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.1
  * d/rules: Drop -S, cmake is inferred
  * Add myself to Uploaders
  * Bump Standards-Version to 4.7.2 (no changes needed)

 -- Christian Kastner <ckk@debian.org>  Fri, 04 Jul 2025 12:13:27 +0200
