=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: devel
 Homepage: https://github.com/ROCm/roctracer
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/roctracer.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/roctracer
 Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Cordell Bloor <cgmb@slerp.xyz>
+Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
+           Christian Kastner <ckk@debian.org>,
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                cmake,
