=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	-DROCTRACER_WERROR=OFF
 
 %:
-	dh $@ -Scmake
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_FLAGS)
