=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocsolver-$1.tar.gz%" \
    https://github.com/rocm/roctracer/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
