## roctracer 7.1.0

=== debian/changelog ===
roctracer (7.1.0-0ubuntu3) resolute; urgency=medium

  * d/control: remove ppc64el builds (LP: #2140348)

 -- Igor Luppi <igor.luppi@canonical.com>  Wed, 28 Jan 2026 17:01:32 -0300

roctracer (7.1.0-0ubuntu2) UNRELEASED; urgency=medium

  * d/{control, rules}: update build dependencies to use upstream llvm-21

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Fri, 19 Dec 2025 16:46:38 +0100

roctracer (7.1.0-0ubuntu1) UNRELEASED; urgency=medium

  [ Zhai Zhaoxuan ]
  * chore: New upstream version 7.1.0 (LP: #2140348)
  * d/copyright: fix license
  * d/control: update build dependencies
  * d/rules: include llvm-toolchain-rocm path
  * d/not-installed: fix the path of new LICENSE file
  * d/p/0001-optional-werror.patch: update for v7.1.0

  [ Igor Luppi ]
  * d/patches/{0002,0003}: refresh patches indexes

 -- Igor Luppi <igor.luppi@canonical.com>  Tue, 02 Dec 2025 19:07:25 -0300

roctracer (6.4.3-0ubuntu2) resolute; urgency=medium

  * d/control: update build-deps to use the 7.1 AMD compiler

 -- Andreas Hasenack <andreas.hasenack@canonical.com>  Tue, 25 Nov 2025 10:05:07 -0300

roctracer (6.4.3-0ubuntu1) questing; urgency=medium

  * New upstream version 6.4.3 (no changes needed)
  * d/control: update maintainer field for ubuntu archive
  * d/control: update build-deps for llvm-toolchain-rocm

 -- Igor Luppi <igor.luppi@canonical.com>  Wed, 01 Oct 2025 15:53:40 -0300

roctracer (6.4.1-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * Update d/gbp.conf to follow DEP-14
  * d/control: remove rocm-device-libs-17 from B-D
  * Update my email and copyright information
  * Add prompt for rocminfo output to libroctx64-4 bug reports

  [ Kentaro Hayashi ]
  * Use d/watch 5

  [ Igor Luppi ]
  * d/watch: fix bug typo rocsolver -> roctracer

 -- Cordell Bloor <cgmb@debian.org>  Fri, 07 Nov 2025 18:13:05 -0700
