=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 CMAKE_FLAGS = \
 	-DFILE_REORG_BACKWARD_COMPATIBILITY=OFF \
 	-DBUILD_ROCTRACER64=OFF \
-	-DROCTRACER_WERROR=OFF
+	-DROCTRACER_WERROR=OFF 
 
 %:
 	dh $@
